diff -Naur --no-dereference a/drivers/net/ethernet/ti/eth_remote_msg.h b/drivers/net/ethernet/ti/eth_remote_msg.h
--- a/drivers/net/ethernet/ti/eth_remote_msg.h	1969-12-31 19:00:00.000000000 -0500
+++ b/drivers/net/ethernet/ti/eth_remote_msg.h	2024-01-28 14:01:31.252353813 -0500
@@ -0,0 +1,448 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+/*
+ * Texas Instruments Ethernet Switch Firmware ABIs
+ *
+ * Copyright (C) 2023 Texas Instruments Incorporated - https://www.ti.com/
+ *
+ */
+
+#ifndef __ETH_REMOTE_MSG_H__
+#define __ETH_REMOTE_MSG_H__
+
+/* Ethernet Switch Firmware Service Endpoint name */
+#define ETHREMOTECFG_FRAMEWORK_SERVICE_NAME   "ti.ethfw.ethdevice"
+
+/* Ethernet Switch Firmware response code : Success */
+#define ETHREMOTECFG_CMDSTATUS_OK		0
+
+/* Ethernet Switch Firmware response code : Try again */
+#define ETHREMOTECFG_CMDSTATUS_EAGAIN		-1
+
+/* Maximum length of message data */
+#define ETHREMOTECFG_MESSAGE_DATA_LEN		486
+
+/* Number of priorities supported by CPSW */
+#define ETHREMOTECFG_PRIORITY_NUM		8
+
+/* MAC Address length in octets */
+#define ETHREMOTECFG_MACADDRLEN		6
+
+/* IPV4 Address length in octets */
+#define ETHREMOTECFG_IPV4ADDRLEN		4
+
+/* Request Ethernet Switch Firmware to use the default VLAN id for the virtual
+ * port; i.e. Virtual MAC Port or Virtual Switch Port.
+ */
+#define ETHREMOTECFG_ETHSWITCH_VLAN_USE_DFLT	0xFFFF
+
+#define ETHREMOTECFG_FWDATE_YEARLEN		4
+#define ETHREMOTECFG_FWDATE_MONTHLEN		3
+#define ETHREMOTECFG_FWDATE_DATELEN		2
+#define ETHREMOTECFG_FW_COMMITSHALEN		8
+
+/*  Ethernet Switch Firmware Version Information
+ *
+ *  API version info for the Ethernet device RPC
+ *  Any remote core client should check API version is compatible with this
+ *  API version
+ */
+/* Ethernet Switch Firmware API version major version */
+#define ETHREMOTECFG_FW_ETHSWITCH_VERSION_MAJOR		0
+/* Ethernet Switch Firmware API version minor version */
+#define ETHREMOTECFG_FW_ETHSWITCH_VERSION_MINOR		4
+/* Ethernet Switch Firmware API version minor revision */
+#define ETHREMOTECFG_FW_ETHSWITCH_VERSION_REVISION		0
+
+/* TX checksum offload feature support */
+#define ETHREMOTECFG_FEATURE_TXCSUM			BIT(0)
+
+/* Note: Feature bit 1 and 2 are intentionally not used */
+
+/* Multicast filter feature support */
+#define ETHREMOTECFG_FEATURE_MC_FILTER			BIT(3)
+
+#define ETHREMOTECFG_TOKEN_NONE                0xFFFF
+
+#define ETHREMOTECFG_IOCTL_INARGS_LEN		480
+#define ETHREMOTECFG_IOCTL_OUTARGS_LEN		480
+
+/*!
+ * \brief Ethernet RPC messages (C2S)
+ */
+enum request_msg_type {
+	ETHREMOTECFG_VIRT_PORT_ALLOC,
+	ETHREMOTECFG_ATTACH,
+	ETHREMOTECFG_ATTACH_EXT,
+	ETHREMOTECFG_DETACH,
+	ETHREMOTECFG_PORT_LINK_STATUS,
+	ETHREMOTECFG_ALLOC_TX,
+	ETHREMOTECFG_ALLOC_RX,
+	ETHREMOTECFG_ALLOC_MAC,
+	ETHREMOTECFG_FREE_TX,
+	ETHREMOTECFG_FREE_RX,
+	ETHREMOTECFG_FREE_MAC,
+	ETHREMOTECFG_MAC_REGISTER,
+	ETHREMOTECFG_MAC_DEREGISTER,
+	ETHREMOTECFG_SET_RX_DEFAULTFLOW,
+	ETHREMOTECFG_DEL_RX_DEFAULTFLOW,
+	ETHREMOTECFG_IPv4_REGISTER,
+	ETHREMOTECFG_IPv4_DEREGISTER,
+	ETHREMOTECFG_CMD_JOIN_VLAN,
+	ETHREMOTECFG_CMD_LEAVE_VLAN,
+	ETHREMOTECFG_FILTER_MAC_ADD,
+	ETHREMOTECFG_FILTER_MAC_DEL,
+	ETHREMOTECFG_PROMISC_ENABLE,
+	ETHREMOTECFG_PROMISC_DISABLE,
+	ETHREMOTECFG_REGISTER_READ,
+	ETHREMOTECFG_REGISTER_WRITE,
+	ETHREMOTECFG_MATCH_ETHTYPE_REGISTER,
+	ETHREMOTECFG_MATCH_ETHTYPE_DEREGISTER,
+	ETHREMOTECFG_REMOTE_TIMER_REGISTER,
+	ETHREMOTECFG_REMOTE_TIMER_DEREGISTER,
+	ETHREMOTECFG_MESSAGE_PING,
+	ETHREMOTECFG_ETHFW_STATUS,
+	ETHREMOTECFG_TEARDOWN_COMPLETE,
+	ETHREMOTECFG_IOCTL,
+	ETHREMOTECFG_CLIENT_DUMPSTATS,
+};
+
+enum client_token {
+	ETHREMOTECFG_NA_CLIENT,
+	ETHREMOTECFG_AUTOSAR_CLIENT,
+	ETHREMOTECFG_RTOS_CLIENT,
+	ETHREMOTECFG_LINUX_CLIENT,
+	ETHREMOTECFG_QNX_CLIENT,
+};
+
+enum notify_msg_type {
+	ETHREMOTECFG_NOTIFYCLIENT_FWINFO,
+	ETHREMOTECFG_NOTIFYCLIENT_HWPUSH,
+	ETHREMOTECFG_NOTIFYTYPE_HWERROR,
+	ETHREMOTECFG_NOTIFYTYPE_HWRECOVERY_COMPLETE,
+	ETHREMOTECFG_NOTIFYCLIENT_CUSTOM,
+	ETHREMOTECFG_NOTIFYCLIENT_LAST,
+};
+
+enum ethfw_status {
+	ETHREMOTECFG_ETHFW_INIT,
+	ETHREMOTECFG_ETHFW_RECOVERY,
+	ETHRC_ETHFW_DEINIT,
+};
+
+enum message_type {
+	ETHREMOTECFG_MSG_REQUEST,
+	ETHREMOTECFG_MSG_NOTIFY,
+	ETHREMOTECFG_MSG_RESPONSE,
+};
+
+struct message_header {
+	u32 token;
+	u32 client_id;
+	u32 msg_type;
+} __packed;
+
+struct message {
+	struct message_header msg_hdr;
+	u32 message_data[120];
+} __packed;
+
+struct request_message_header {
+	struct message_header msg_hdr;
+	u32 request_type;
+	u32 request_id;
+} __packed;
+
+struct response_message_header {
+	struct message_header msg_hdr;
+	u32 response_type; /* Same as request_type */
+	u32 response_id;
+	int response_status;
+} __packed;
+
+struct notify_message_header {
+	struct message_header msg_hdr;
+	u32 notify_type;
+} __packed;
+
+struct ethfw_rpc_version_info {
+	u32 major;
+	u32 minor;
+	u32 rev;
+	char year[ETHREMOTECFG_FWDATE_YEARLEN];
+	char month[ETHREMOTECFG_FWDATE_MONTHLEN];
+	char date[ETHREMOTECFG_FWDATE_DATELEN];
+	char commit_hash[ETHREMOTECFG_FW_COMMITSHALEN];
+} __packed;
+
+struct ethfw_firmware_version_notify {
+	struct notify_message_header notify_msg_hdr;
+	struct ethfw_rpc_version_info ethfw_info;
+	u64 permission_flags;
+	u32 uart_connected;
+	u32 uart_id;
+} __packed;
+
+struct common_response_message {
+	struct response_message_header response_msg_hdr;
+} __packed;
+
+struct common_request_message {
+	struct request_message_header request_msg_hdr;
+} __packed;
+
+struct common_notify_message {
+	struct notify_message_header notify_msg_hdr;
+} __packed;
+
+struct virt_port_alloc_response {
+	struct response_message_header response_msg_hdr;
+	/* Port mask denoting absolute virtual switch ports allocated */
+	u32 switch_port_mask;
+	/* Port mask denoting absolute virtual MAC ports allocated */
+	u32 mac_port_mask;
+} __packed;
+
+struct attach_request {
+	struct request_message_header request_msg_hdr;
+	/* Virtual port which needs core attach */
+	u32 virt_port;
+} __packed;
+
+struct attach_response {
+	struct response_message_header response_msg_hdr;
+	/* MTU of RX packet */
+	u32 rx_mtu;
+	/* MTU of TX packet per priority */
+	u32 tx_mtu[ETHREMOTECFG_PRIORITY_NUM];
+	/* Feature bitmask based on defines ETHREMOTECFG_FEATURE_xxx */
+	u32 features;
+} __packed;
+
+struct attach_ext_response {
+	struct response_message_header response_msg_hdr;
+	/* MTU of RX packet */
+	u32 rx_mtu;
+	/* MTU of TX packet per priority */
+	u32 tx_mtu[ETHREMOTECFG_PRIORITY_NUM];
+	/* Allocated RX flow index base */
+	u32 rx_flow_idx_base;
+	/* Allocated flow index offset */
+	u32 rx_flow_idx_offset;
+	/* TX PSIL Peer destination thread id which should be paired with the TX UDMA channel */
+	u32 tx_psil_dest_id;
+	/* MAC address allocated */
+	u8 mac_addr[ETHREMOTECFG_MACADDRLEN];
+	/* Feature bitmask based on defines ETHREMOTECFG_FEATURE_xxx */
+	u32 features;
+	/* RX PSIL Peer source thread id */
+	u32 rx_psil_src_id;
+} __packed;
+
+struct rx_flow_alloc_response {
+	struct response_message_header response_msg_hdr;
+	/* Allocated RX flow index base */
+	u32 rx_flow_idx_base;
+	/* Allocated flow index offset */
+	u32 rx_flow_idx_offset;
+	/* RX PSIL Peer source thread id */
+	u32 rx_psil_src_id;
+} __packed;
+
+struct tx_psil_alloc_response {
+	struct response_message_header response_msg_hdr;
+	/* TX PSIL peer destination thread id which should be paired with the TX UDMA channel */
+	u32 tx_psil_dest_id;
+} __packed;
+
+struct mac_alloc_request {
+	struct request_message_header request_msg_hdr;
+	/* Allocated MAC address */
+	u8 mac_addr[ETHREMOTECFG_MACADDRLEN];
+} __packed;
+
+struct rx_flow_release_request {
+	struct request_message_header request_msg_hdr;
+	/* RX flow index base */
+	u32 rx_flow_idx_base;
+	/* RX flow index offset */
+	u32 rx_flow_idx_offset;
+} __packed;
+
+struct tx_psil_release_request {
+	struct request_message_header request_msg_hdr;
+	/* TX PSIL Peer destination thread id to be freed */
+	u32 tx_psil_dest_id;
+} __packed;
+
+struct mac_release_request {
+	struct request_message_header request_msg_hdr;
+	/* MAC address to be freed */
+	u8 mac_addr[ETHREMOTECFG_MACADDRLEN];
+} __packed;
+
+struct mac_rx_flow_register_request {
+	struct request_message_header request_msg_hdr;
+	/* MAC address which needs to be registered */
+	u8 mac_addr[ETHREMOTECFG_MACADDRLEN];
+	/* RX flow index Base */
+	u32 rx_flow_idx_base;
+	/* RX flow index offset to which the MAC address needs to be registered */
+	u32 rx_flow_idx_offset;
+} __packed;
+
+struct ipv4_register_request {
+	struct request_message_header request_msg_hdr;
+	/* IPv4 Address */
+	u8 ipv4_addr[ETHREMOTECFG_IPV4ADDRLEN];
+	/* MAC address associated with the IP address which should be added to
+	 * the ARP table
+	 */
+	u8 mac_addr[ETHREMOTECFG_MACADDRLEN];
+} __packed;
+
+struct ipv4_deregister_request {
+	struct request_message_header request_msg_hdr;
+	/* IPv4 Address */
+	u8 ipv4_addr[ETHREMOTECFG_IPV4ADDRLEN];
+} __packed;
+
+struct default_rx_flow_register_request {
+	struct request_message_header request_msg_hdr;
+	/* RX flow index Base */
+	u32 rx_flow_idx_base;
+	/* RX flow index offset */
+	u32 rx_flow_idx_offset;
+} __packed;
+
+struct port_link_status_response {
+	struct response_message_header response_msg_hdr;
+	/* Link status of the port */
+	bool link_up;
+	/* Link speed */
+	u32 speed;
+	/* Duplex mode */
+	u32 duplex;
+} __packed;
+
+struct add_ether_type_rx_flow_request {
+	struct request_message_header request_msg_hdr;
+	/* EtherType to be associated with the flow */
+	u16 ether_type;
+	/* Allocated flow's base */
+	u32 rx_flow_idx_base;
+	/* Allocated flow's offset */
+	u32 rx_flow_idx_offset;
+} __packed;
+
+struct del_ether_type_rx_flow_request {
+	struct request_message_header request_msg_hdr;
+	/* EtherType associated with the flow */
+	u16 ether_type;
+} __packed;
+
+struct add_mcast_vlan_rx_flow_request {
+	struct request_message_header request_msg_hdr;
+	/* Multicast MAC address to be added */
+	u8 mac_addr[ETHREMOTECFG_MACADDRLEN];
+	/* VLAN id */
+	u16 vlan_id;
+	/* RX flow index from which the MAC_address association will be added.
+	 * It's applicable only for _exclusive multicast traffic_
+	 */
+	u32 rx_flow_idx_base;
+	/* RX flow index offset */
+	u32 rx_flow_idx_offset;
+} __packed;
+
+struct del_mcast_vlan_rx_flow_request {
+	struct request_message_header request_msg_hdr;
+	/* Multicast MAC address to be added */
+	u8 mac_addr[ETHREMOTECFG_MACADDRLEN];
+	/* VLAN id */
+	u16 vlan_id;
+} __packed;
+
+struct ping_request {
+	struct request_message_header request_msg_hdr;
+	/* Data which will be responded back by the server */
+	u32 ping_request_data[ETHREMOTECFG_MESSAGE_DATA_LEN];
+} __packed;
+
+struct ping_response {
+	struct response_message_header response_msg_hdr;
+	/* Data which will be responded back by the server */
+	u32 ping_response_data[ETHREMOTECFG_MESSAGE_DATA_LEN];
+} __packed;
+
+struct remote_timer_register_request {
+	struct request_message_header request_msg_hdr;
+	/* Hardware Push Number to be used for timesync router configuration */
+	u8 hw_push_number;
+	/* Timer Id to be used for timesync router configuration */
+	u8 timer_id;
+} __packed;
+
+struct remote_timer_deregister_request {
+	struct request_message_header request_msg_hdr;
+	/* Hardware Push Number to be used for timesync router configuration */
+	u8 hw_push_number;
+} __packed;
+
+struct ioctl_request {
+	struct request_message_header request_msg_hdr;
+	/* IOCTL Command ID */
+	u32 cmd;
+	/* IOCTL input arguments length */
+	u32 in_args_len;
+	/* IOCTL input arguments */
+	u64 in_args[(ETHREMOTECFG_IOCTL_INARGS_LEN / sizeof(u64))];
+	/* IOTCL output arguments length */
+	u32 out_args_len;
+};
+
+struct ioctl_response {
+	struct request_message_header request_msg_hdr;
+	/* IOCTL Command ID */
+	u32 cmd;
+	/* IOCTL output arguments length */
+	u32 out_args_len;
+	/* IOCTL output arguments */
+	u64 out_args[(ETHREMOTECFG_IOCTL_OUTARGS_LEN / sizeof(u64))];
+};
+
+struct register_write_request {
+	struct request_message_header request_msg_hdr;
+	/* Register address */
+	u32 register_address;
+	/* Value which needs to be written */
+	u32 value;
+} __packed;
+
+struct register_read_request {
+	/* Request message common header */
+	struct request_message_header request_msg_hdr;
+	/* Register address */
+	u32 register_address;
+} __packed;
+
+struct register_read_response {
+	struct response_message_header response_msg_hdr;
+	/* Value which has been read */
+	u32 value;
+} __packed;
+
+struct server_status_response {
+	struct response_message_header response_msg_hdr;
+	/* Server status */
+	u32 status;
+};
+
+struct hw_msg_push_notify_message {
+	struct notify_message_header notify_msg_hdr;
+	/* CPTS hardware push number */
+	u32 cpts_hw_push_number;
+	/* CPTS hardware push event timestamp  */
+	u64 timestamp;
+} __packed;
+
+#endif /* __ETH_REMOTE_MSG_H__ */
diff -Naur --no-dereference a/drivers/net/ethernet/ti/icssg_classifier.c b/drivers/net/ethernet/ti/icssg_classifier.c
--- a/drivers/net/ethernet/ti/icssg_classifier.c	1969-12-31 19:00:00.000000000 -0500
+++ b/drivers/net/ethernet/ti/icssg_classifier.c	2024-01-28 14:01:31.252353813 -0500
@@ -0,0 +1,362 @@
+// SPDX-License-Identifier: GPL-2.0
+/* Texas Instruments ICSSG Ethernet Driver
+ *
+ * Copyright (C) 2018-2022 Texas Instruments Incorporated - https://www.ti.com/
+ *
+ */
+
+#include <linux/etherdevice.h>
+#include <linux/types.h>
+#include <linux/regmap.h>
+
+#include "icssg_prueth.h"
+
+#define ICSSG_NUM_CLASSIFIERS	16
+#define ICSSG_NUM_FT1_SLOTS	8
+#define ICSSG_NUM_FT3_SLOTS	16
+
+#define ICSSG_NUM_CLASSIFIERS_IN_USE	5
+
+/* Filter 1 - FT1 */
+#define FT1_NUM_SLOTS	8
+#define FT1_SLOT_SIZE	0x10	/* bytes */
+
+/* offsets from FT1 slot base i.e. slot 1 start */
+#define FT1_DA0		0x0
+#define FT1_DA1		0x4
+#define FT1_DA0_MASK	0x8
+#define FT1_DA1_MASK	0xc
+
+#define FT1_N_REG(slize, n, reg)	(offs[slice].ft1_slot_base + FT1_SLOT_SIZE * (n) + (reg))
+
+#define FT1_LEN_MASK		GENMASK(19, 16)
+#define FT1_LEN_SHIFT		16
+#define FT1_LEN(len)		(((len) << FT1_LEN_SHIFT) & FT1_LEN_MASK)
+#define FT1_START_MASK		GENMASK(14, 0)
+#define FT1_START(start)	((start) & FT1_START_MASK)
+#define FT1_MATCH_SLOT(n)	(GENMASK(23, 16) & (BIT(n) << 16))
+
+enum ft1_cfg_type {
+	FT1_CFG_TYPE_DISABLED = 0,
+	FT1_CFG_TYPE_EQ,
+	FT1_CFG_TYPE_GT,
+	FT1_CFG_TYPE_LT,
+};
+
+#define FT1_CFG_SHIFT(n)	(2 * (n))
+#define FT1_CFG_MASK(n)		(0x3 << FT1_CFG_SHIFT((n)))
+
+/* Filter 3 -  FT3 */
+#define FT3_NUM_SLOTS	16
+#define FT3_SLOT_SIZE	0x20	/* bytes */
+
+/* offsets from FT3 slot n's base */
+#define FT3_START		0
+#define FT3_START_AUTO		0x4
+#define FT3_START_OFFSET	0x8
+#define FT3_JUMP_OFFSET		0xc
+#define FT3_LEN			0x10
+#define FT3_CFG			0x14
+#define FT3_T			0x18
+#define FT3_T_MASK		0x1c
+
+#define FT3_N_REG(slize, n, reg)	(offs[slice].ft3_slot_base + FT3_SLOT_SIZE * (n) + (reg))
+
+/* offsets from rx_class n's base */
+#define RX_CLASS_AND_EN		0
+#define RX_CLASS_OR_EN		0x4
+#define RX_CLASS_NUM_SLOTS	16
+#define RX_CLASS_EN_SIZE	0x8	/* bytes */
+
+#define RX_CLASS_N_REG(slice, n, reg)	(offs[slice].rx_class_base + RX_CLASS_EN_SIZE * (n) + (reg))
+
+/* RX Class Gates */
+#define RX_CLASS_GATES_SIZE	0x4	/* bytes */
+
+#define RX_CLASS_GATES_N_REG(slice, n)	\
+	(offs[slice].rx_class_gates_base + RX_CLASS_GATES_SIZE * (n))
+
+#define RX_CLASS_GATES_ALLOW_MASK	BIT(6)
+#define RX_CLASS_GATES_RAW_MASK		BIT(5)
+#define RX_CLASS_GATES_PHASE_MASK	BIT(4)
+
+/* RX Class traffic data matching bits */
+#define RX_CLASS_FT_UC			BIT(31)
+#define RX_CLASS_FT_MC			BIT(30)
+#define RX_CLASS_FT_BC			BIT(29)
+#define RX_CLASS_FT_FW			BIT(28)
+#define RX_CLASS_FT_RCV			BIT(27)
+#define RX_CLASS_FT_VLAN		BIT(26)
+#define RX_CLASS_FT_DA_P		BIT(25)
+#define RX_CLASS_FT_DA_I		BIT(24)
+#define RX_CLASS_FT_FT1_MATCH_MASK	GENMASK(23, 16)
+#define RX_CLASS_FT_FT1_MATCH_SHIFT	16
+#define RX_CLASS_FT_FT3_MATCH_MASK	GENMASK(15, 0)
+#define RX_CLASS_FT_FT3_MATCH_SHIFT	0
+
+#define RX_CLASS_FT_FT1_MATCH(slot)	\
+	((BIT(slot) << RX_CLASS_FT_FT1_MATCH_SHIFT) & RX_CLASS_FT_FT1_MATCH_MASK)
+
+enum rx_class_sel_type {
+	RX_CLASS_SEL_TYPE_OR = 0,
+	RX_CLASS_SEL_TYPE_AND = 1,
+	RX_CLASS_SEL_TYPE_OR_AND_AND = 2,
+	RX_CLASS_SEL_TYPE_OR_OR_AND = 3,
+};
+
+#define FT1_CFG_SHIFT(n)	(2 * (n))
+#define FT1_CFG_MASK(n)		(0x3 << FT1_CFG_SHIFT((n)))
+
+#define RX_CLASS_SEL_SHIFT(n)	(2 * (n))
+#define RX_CLASS_SEL_MASK(n)	(0x3 << RX_CLASS_SEL_SHIFT((n)))
+
+#define ICSSG_CFG_OFFSET	0
+#define MAC_INTERFACE_0		0x18
+#define MAC_INTERFACE_1		0x1c
+
+#define ICSSG_CFG_RX_L2_G_EN	BIT(2)
+
+/* These are register offsets per PRU */
+struct miig_rt_offsets {
+	u32 mac0;
+	u32 mac1;
+	u32 ft1_start_len;
+	u32 ft1_cfg;
+	u32 ft1_slot_base;
+	u32 ft3_slot_base;
+	u32 ft3_p_base;
+	u32 ft_rx_ptr;
+	u32 rx_class_base;
+	u32 rx_class_cfg1;
+	u32 rx_class_cfg2;
+	u32 rx_class_gates_base;
+	u32 rx_green;
+	u32 rx_rate_cfg_base;
+	u32 rx_rate_src_sel0;
+	u32 rx_rate_src_sel1;
+	u32 tx_rate_cfg_base;
+	u32 stat_base;
+	u32 tx_hsr_tag;
+	u32 tx_hsr_seq;
+	u32 tx_vlan_type;
+	u32 tx_vlan_ins;
+};
+
+/* These are the offset values for miig_rt_offsets registers */
+static const struct miig_rt_offsets offs[] = {
+	/* PRU0 */
+	{
+		0x8,
+		0xc,
+		0x80,
+		0x84,
+		0x88,
+		0x108,
+		0x308,
+		0x408,
+		0x40c,
+		0x48c,
+		0x490,
+		0x494,
+		0x4d4,
+		0x4e4,
+		0x504,
+		0x508,
+		0x50c,
+		0x54c,
+		0x63c,
+		0x640,
+		0x644,
+		0x648,
+	},
+	/* PRU1 */
+	{
+		0x10,
+		0x14,
+		0x64c,
+		0x650,
+		0x654,
+		0x6d4,
+		0x8d4,
+		0x9d4,
+		0x9d8,
+		0xa58,
+		0xa5c,
+		0xa60,
+		0xaa0,
+		0xab0,
+		0xad0,
+		0xad4,
+		0xad8,
+		0xb18,
+		0xc08,
+		0xc0c,
+		0xc10,
+		0xc14,
+	},
+};
+
+static void rx_class_ft1_set_start_len(struct regmap *miig_rt, int slice,
+				       u16 start, u8 len)
+{
+	u32 offset, val;
+
+	offset = offs[slice].ft1_start_len;
+	val = FT1_LEN(len) | FT1_START(start);
+	regmap_write(miig_rt, offset, val);
+}
+
+static void rx_class_ft1_set_da(struct regmap *miig_rt, int slice,
+				int n, const u8 *addr)
+{
+	u32 offset;
+
+	offset = FT1_N_REG(slice, n, FT1_DA0);
+	regmap_write(miig_rt, offset, (u32)(addr[0] | addr[1] << 8 |
+		     addr[2] << 16 | addr[3] << 24));
+	offset = FT1_N_REG(slice, n, FT1_DA1);
+	regmap_write(miig_rt, offset, (u32)(addr[4] | addr[5] << 8));
+}
+
+static void rx_class_ft1_set_da_mask(struct regmap *miig_rt, int slice,
+				     int n, const u8 *addr)
+{
+	u32 offset;
+
+	offset = FT1_N_REG(slice, n, FT1_DA0_MASK);
+	regmap_write(miig_rt, offset, (u32)(addr[0] | addr[1] << 8 |
+		     addr[2] << 16 | addr[3] << 24));
+	offset = FT1_N_REG(slice, n, FT1_DA1_MASK);
+	regmap_write(miig_rt, offset, (u32)(addr[4] | addr[5] << 8));
+}
+
+static void rx_class_ft1_cfg_set_type(struct regmap *miig_rt, int slice, int n,
+				      enum ft1_cfg_type type)
+{
+	u32 offset;
+
+	offset = offs[slice].ft1_cfg;
+	regmap_update_bits(miig_rt, offset, FT1_CFG_MASK(n),
+			   type << FT1_CFG_SHIFT(n));
+}
+
+static void rx_class_sel_set_type(struct regmap *miig_rt, int slice, int n,
+				  enum rx_class_sel_type type)
+{
+	u32 offset;
+
+	offset = offs[slice].rx_class_cfg1;
+	regmap_update_bits(miig_rt, offset, RX_CLASS_SEL_MASK(n),
+			   type << RX_CLASS_SEL_SHIFT(n));
+}
+
+static void rx_class_set_and(struct regmap *miig_rt, int slice, int n,
+			     u32 data)
+{
+	u32 offset;
+
+	offset = RX_CLASS_N_REG(slice, n, RX_CLASS_AND_EN);
+	regmap_write(miig_rt, offset, data);
+}
+
+static void rx_class_set_or(struct regmap *miig_rt, int slice, int n,
+			    u32 data)
+{
+	u32 offset;
+
+	offset = RX_CLASS_N_REG(slice, n, RX_CLASS_OR_EN);
+	regmap_write(miig_rt, offset, data);
+}
+
+void icssg_class_set_host_mac_addr(struct regmap *miig_rt, const u8 *mac)
+{
+	regmap_write(miig_rt, MAC_INTERFACE_0, (u32)(mac[0] | mac[1] << 8 |
+		     mac[2] << 16 | mac[3] << 24));
+	regmap_write(miig_rt, MAC_INTERFACE_1, (u32)(mac[4] | mac[5] << 8));
+}
+
+void icssg_class_set_mac_addr(struct regmap *miig_rt, int slice, u8 *mac)
+{
+	regmap_write(miig_rt, offs[slice].mac0, (u32)(mac[0] | mac[1] << 8 |
+		     mac[2] << 16 | mac[3] << 24));
+	regmap_write(miig_rt, offs[slice].mac1, (u32)(mac[4] | mac[5] << 8));
+}
+
+/* disable all RX traffic */
+void icssg_class_disable(struct regmap *miig_rt, int slice)
+{
+	u32 data, offset;
+	int n;
+
+	/* Enable RX_L2_G */
+	regmap_update_bits(miig_rt, ICSSG_CFG_OFFSET, ICSSG_CFG_RX_L2_G_EN,
+			   ICSSG_CFG_RX_L2_G_EN);
+
+	for (n = 0; n < ICSSG_NUM_CLASSIFIERS; n++) {
+		/* AND_EN = 0 */
+		rx_class_set_and(miig_rt, slice, n, 0);
+		/* OR_EN = 0 */
+		rx_class_set_or(miig_rt, slice, n, 0);
+
+		/* set CFG1 to OR */
+		rx_class_sel_set_type(miig_rt, slice, n, RX_CLASS_SEL_TYPE_OR);
+
+		/* configure gate */
+		offset = RX_CLASS_GATES_N_REG(slice, n);
+		regmap_read(miig_rt, offset, &data);
+		/* clear class_raw so we go through filters */
+		data &= ~RX_CLASS_GATES_RAW_MASK;
+		/* set allow and phase mask */
+		data |= RX_CLASS_GATES_ALLOW_MASK | RX_CLASS_GATES_PHASE_MASK;
+		regmap_write(miig_rt, offset, data);
+	}
+
+	/* FT1 Disabled */
+	for (n = 0; n < ICSSG_NUM_FT1_SLOTS; n++) {
+		const u8 addr[] = { 0, 0, 0, 0, 0, 0, };
+
+		rx_class_ft1_cfg_set_type(miig_rt, slice, n,
+					  FT1_CFG_TYPE_DISABLED);
+		rx_class_ft1_set_da(miig_rt, slice, n, addr);
+		rx_class_ft1_set_da_mask(miig_rt, slice, n, addr);
+	}
+
+	/* clear CFG2 */
+	regmap_write(miig_rt, offs[slice].rx_class_cfg2, 0);
+}
+
+void icssg_class_default(struct regmap *miig_rt, int slice, bool allmulti)
+{
+	u32 data;
+
+	/* defaults */
+	icssg_class_disable(miig_rt, slice);
+
+	/* Setup Classifier */
+	/* match on Broadcast or MAC_PRU address */
+	data = RX_CLASS_FT_BC | RX_CLASS_FT_DA_P;
+
+	/* multicast */
+	if (allmulti)
+		data |= RX_CLASS_FT_MC;
+
+	rx_class_set_or(miig_rt, slice, 0, data);
+
+	/* set CFG1 for OR_OR_AND for classifier */
+	rx_class_sel_set_type(miig_rt, slice, 0,
+			      RX_CLASS_SEL_TYPE_OR_OR_AND);
+
+	/* clear CFG2 */
+	regmap_write(miig_rt, offs[slice].rx_class_cfg2, 0);
+}
+
+/* required for SAV check */
+void icssg_ft1_set_mac_addr(struct regmap *miig_rt, int slice, u8 *mac_addr)
+{
+	const u8 mask_addr[] = { 0, 0, 0, 0, 0, 0, };
+
+	rx_class_ft1_set_start_len(miig_rt, slice, 6, 6);
+	rx_class_ft1_set_da(miig_rt, slice, 0, mac_addr);
+	rx_class_ft1_set_da_mask(miig_rt, slice, 0, mask_addr);
+	rx_class_ft1_cfg_set_type(miig_rt, slice, 0, FT1_CFG_TYPE_EQ);
+}
